UIPackage
Menu

Framework

Change language

Boilerplate repo

Navigation Menu

navigation-menuui

Top-of-page horizontal navigation with hover/click triggered megamenus. Use for marketing sites and product navs that need rich content — featured links, mini-cards, and submenu columns.

Also available for React ->

Installation

$npx shadcn-vue@latest add https://uipkge.dev/r/vue/navigation-menu.json
Named registry:npx shadcn-vue@latest add @uipkge/navigation-menuInstalls to:app/components/ui/navigation-menu/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
classHTMLAttributes['class']optional
viewportbooleantrueoptional

Used by

Files installed (11)

  • app/components/ui/navigation-menu/NavigationMenu.vue1.1 kB
    <script setup lang="ts">
    import type { NavigationMenuRootEmits, NavigationMenuRootProps } from 'reka-ui'
    import type { HTMLAttributes } from 'vue'
    import { reactiveOmit } from '@vueuse/core'
    import { NavigationMenuRoot, useForwardPropsEmits } from 'reka-ui'
    import { cn } from '@/lib/utils'
    import NavigationMenuViewport from './NavigationMenuViewport.vue'
    
    const props = withDefaults(
      defineProps<
        NavigationMenuRootProps & {
          class?: HTMLAttributes['class']
          viewport?: boolean
        }
      >(),
      {
        viewport: true,
      },
    )
    const emits = defineEmits<NavigationMenuRootEmits>()
    
    const delegatedProps = reactiveOmit(props, 'class', 'viewport')
    const forwarded = useForwardPropsEmits(delegatedProps, emits)
    </script>
    
    <template>
      <NavigationMenuRoot
        v-slot="slotProps"
        data-uipkge
        data-slot="navigation-menu"
        :data-viewport="viewport"
        v-bind="forwarded"
        :class="cn('group/navigation-menu relative flex max-w-max flex-1 items-center justify-center', props.class)"
      >
        <slot v-bind="slotProps" />
        <NavigationMenuViewport v-if="viewport" />
      </NavigationMenuRoot>
    </template>
    
  • app/components/ui/navigation-menu/NavigationMenuContent.vue2 kB
  • app/components/ui/navigation-menu/navigation-menu-content.variants.ts0.8 kB
  • app/components/ui/navigation-menu/NavigationMenuIndicator.vue1 kB
  • app/components/ui/navigation-menu/NavigationMenuItem.vue0.6 kB
  • app/components/ui/navigation-menu/NavigationMenuLink.vue1.2 kB
  • app/components/ui/navigation-menu/NavigationMenuList.vue0.7 kB
  • app/components/ui/navigation-menu/NavigationMenuTrigger.vue1 kB
  • app/components/ui/navigation-menu/NavigationMenuViewport.vue1.2 kB
  • app/components/ui/navigation-menu/navigation-menu.variants.ts0.9 kB
  • app/components/ui/navigation-menu/index.ts0.9 kB

Raw manifest:https://uipkge.dev/r/vue/navigation-menu.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Navigation Menu

navigation-menuui

Top-of-page horizontal navigation with hover/click triggered megamenus. Use for marketing sites and product navs that need rich content — featured links, mini-cards, and submenu columns.

Also available for Vue ->

Installation

$npx shadcn@latest add https://uipkge.dev/r/react/navigation-menu.json
Named registry:npx shadcn@latest add @uipkge-react/navigation-menuInstalls to:components/ui/navigation-menu/

Examples

Loading interactive previews…

Used by

Files installed (3)

  • components/ui/navigation-menu/navigation-menu.tsx7.6 kB
    'use client'
    
    import * as React from 'react'
    import * as NavigationMenuPrimitive from '@radix-ui/react-navigation-menu'
    import { ChevronDown } from 'lucide-react'
    import { cn } from '@/lib/utils'
    import { navigationMenuTriggerStyle } from './navigation-menu.variants'
    
    const NavigationMenu = React.forwardRef<
      React.ElementRef<typeof NavigationMenuPrimitive.Root>,
      React.ComponentPropsWithoutRef<typeof NavigationMenuPrimitive.Root> & {
        viewport?: boolean
      }
    >(({ className, children, viewport = true, ...props }, ref) => (
      <NavigationMenuPrimitive.Root
        ref={ref}
        data-uipkge=""
        data-slot="navigation-menu"
        data-viewport={viewport}
        className={cn('group/navigation-menu relative flex max-w-max flex-1 items-center justify-center', className)}
        {...props}
      >
        {children}
        {viewport && <NavigationMenuViewport />}
      </NavigationMenuPrimitive.Root>
    ))
    NavigationMenu.displayName = NavigationMenuPrimitive.Root.displayName
    
    const NavigationMenuList = React.forwardRef<
      React.ElementRef<typeof NavigationMenuPrimitive.List>,
      React.ComponentPropsWithoutRef<typeof NavigationMenuPrimitive.List>
    >(({ className, ...props }, ref) => (
      <NavigationMenuPrimitive.List
        ref={ref}
        data-uipkge=""
        data-slot="navigation-menu-list"
        className={cn('group flex flex-1 list-none items-center justify-center gap-1', className)}
        {...props}
      />
    ))
    NavigationMenuList.displayName = NavigationMenuPrimitive.List.displayName
    
    const NavigationMenuItem = React.forwardRef<
      React.ElementRef<typeof NavigationMenuPrimitive.Item>,
      React.ComponentPropsWithoutRef<typeof NavigationMenuPrimitive.Item>
    >(({ className, ...props }, ref) => (
      <NavigationMenuPrimitive.Item
        ref={ref}
        data-uipkge=""
        data-slot="navigation-menu-item"
        className={cn('relative', className)}
        {...props}
      />
    ))
    NavigationMenuItem.displayName = NavigationMenuPrimitive.Item.displayName
    
    const NavigationMenuTrigger = React.forwardRef<
      React.ElementRef<typeof NavigationMenuPrimitive.Trigger>,
      React.ComponentPropsWithoutRef<typeof NavigationMenuPrimitive.Trigger>
    >(({ className, children, ...props }, ref) => (
      <NavigationMenuPrimitive.Trigger
        ref={ref}
        data-uipkge=""
        data-slot="navigation-menu-trigger"
        className={cn(navigationMenuTriggerStyle(), 'group', className)}
        {...props}
      >
        {children}
        <ChevronDown
          className="relative top-[1px] ml-1 size-3 transition duration-300 group-data-[state=open]:rotate-180"
          aria-hidden="true"
        />
      </NavigationMenuPrimitive.Trigger>
    ))
    NavigationMenuTrigger.displayName = NavigationMenuPrimitive.Trigger.displayName
    
    const NavigationMenuContent = React.forwardRef<
      React.ElementRef<typeof NavigationMenuPrimitive.Content>,
      React.ComponentPropsWithoutRef<typeof NavigationMenuPrimitive.Content>
    >(({ className, ...props }, ref) => (
      <NavigationMenuPrimitive.Content
        ref={ref}
        data-uipkge=""
        data-slot="navigation-menu-content"
        className={cn(
          'data-[motion^=from-]:motion-safe:animate-in data-[motion^=to-]:motion-safe:animate-out data-[motion^=from-]:motion-safe:fade-in data-[motion^=to-]:motion-safe:fade-out data-[motion=from-end]:motion-safe:slide-in-from-right-52 data-[motion=from-start]:motion-safe:slide-in-from-left-52 data-[motion=to-end]:motion-safe:slide-out-to-right-52 data-[motion=to-start]:motion-safe:slide-out-to-left-52 top-0 left-0 w-full p-2 pr-2.5 md:absolute md:w-auto',
          'group-data-[viewport=false]/navigation-menu:bg-popover group-data-[viewport=false]/navigation-menu:text-popover-foreground group-data-[viewport=false]/navigation-menu:data-[state=open]:motion-safe:animate-in group-data-[viewport=false]/navigation-menu:data-[state=closed]:motion-safe:animate-out group-data-[viewport=false]/navigation-menu:data-[state=closed]:motion-safe:zoom-out-95 group-data-[viewport=false]/navigation-menu:data-[state=open]:motion-safe:zoom-in-95 group-data-[viewport=false]/navigation-menu:data-[state=open]:motion-safe:fade-in-0 group-data-[viewport=false]/navigation-menu:data-[state=closed]:motion-safe:fade-out-0 group-data-[viewport=false]/navigation-menu:top-full group-data-[viewport=false]/navigation-menu:mt-1.5 group-data-[viewport=false]/navigation-menu:overflow-hidden group-data-[viewport=false]/navigation-menu:rounded-md group-data-[viewport=false]/navigation-menu:border group-data-[viewport=false]/navigation-menu:shadow group-data-[viewport=false]/navigation-menu:duration-200 **:data-[slot=navigation-menu-link]:focus:ring-0 **:data-[slot=navigation-menu-link]:focus:outline-none',
          className,
        )}
        {...props}
      />
    ))
    NavigationMenuContent.displayName = NavigationMenuPrimitive.Content.displayName
    
    const NavigationMenuLink = React.forwardRef<
      React.ElementRef<typeof NavigationMenuPrimitive.Link>,
      React.ComponentPropsWithoutRef<typeof NavigationMenuPrimitive.Link>
    >(({ className, ...props }, ref) => (
      <NavigationMenuPrimitive.Link
        ref={ref}
        data-uipkge=""
        data-slot="navigation-menu-link"
        className={cn(
          "data-active:focus:bg-accent data-active:hover:bg-accent data-active:bg-accent/50 data-active:text-accent-foreground hover:bg-accent hover:text-accent-foreground focus:bg-accent focus:text-accent-foreground ring-ring/10 dark:ring-ring/20 dark:outline-ring/40 outline-ring/50 [&_svg:not([class*='text-'])]:text-muted-foreground flex flex-col gap-1 rounded-sm p-2 text-sm transition-[color,box-shadow] focus-visible:ring-4 focus-visible:outline-1 [&_svg:not([class*='size-'])]:size-4",
          className,
        )}
        {...props}
      />
    ))
    NavigationMenuLink.displayName = NavigationMenuPrimitive.Link.displayName
    
    const NavigationMenuIndicator = React.forwardRef<
      React.ElementRef<typeof NavigationMenuPrimitive.Indicator>,
      React.ComponentPropsWithoutRef<typeof NavigationMenuPrimitive.Indicator>
    >(({ className, ...props }, ref) => (
      <NavigationMenuPrimitive.Indicator
        ref={ref}
        data-uipkge=""
        data-slot="navigation-menu-indicator"
        className={cn(
          'data-[state=visible]:motion-safe:animate-in data-[state=hidden]:motion-safe:animate-out data-[state=hidden]:motion-safe:fade-out data-[state=visible]:motion-safe:fade-in top-full z-[1] flex h-1.5 items-end justify-center overflow-hidden',
          className,
        )}
        {...props}
      >
        <div className="bg-border relative top-[60%] h-2 w-2 rotate-45 rounded-tl-sm shadow-md" />
      </NavigationMenuPrimitive.Indicator>
    ))
    NavigationMenuIndicator.displayName = NavigationMenuPrimitive.Indicator.displayName
    
    const NavigationMenuViewport = React.forwardRef<
      React.ElementRef<typeof NavigationMenuPrimitive.Viewport>,
      React.ComponentPropsWithoutRef<typeof NavigationMenuPrimitive.Viewport>
    >(({ className, ...props }, ref) => (
      <div className="absolute top-full left-0 isolate z-50 flex justify-center">
        <NavigationMenuPrimitive.Viewport
          ref={ref}
          data-uipkge=""
          data-slot="navigation-menu-viewport"
          className={cn(
            'origin-top-center bg-popover text-popover-foreground data-[state=open]:motion-safe:animate-in data-[state=closed]:motion-safe:animate-out data-[state=closed]:motion-safe:zoom-out-95 data-[state=open]:motion-safe:zoom-in-90 relative left-[var(--radix-navigation-menu-viewport-left)] mt-1.5 h-[var(--radix-navigation-menu-viewport-height)] w-full overflow-hidden rounded-md border shadow md:w-[var(--radix-navigation-menu-viewport-width)]',
            className,
          )}
          {...props}
        />
      </div>
    ))
    NavigationMenuViewport.displayName = NavigationMenuPrimitive.Viewport.displayName
    
    export {
      NavigationMenu,
      NavigationMenuList,
      NavigationMenuItem,
      NavigationMenuContent,
      NavigationMenuTrigger,
      NavigationMenuLink,
      NavigationMenuIndicator,
      NavigationMenuViewport,
    }
    
  • components/ui/navigation-menu/navigation-menu.variants.ts0.9 kB
  • components/ui/navigation-menu/index.ts0.3 kB

Raw manifest:https://uipkge.dev/r/react/navigation-menu.json